﻿; ---------------------------------------------------------------------------------------
;           Name: SweetyVD
;    Description: Sweety Visual Designer
;     dependency: SweetyVDmodule.pbi (Sweety Visual Designer Module)
;         Author: ChrisR
;           Date: 2017-03-14
;        Version: 1.5
;     PB-Version: 5.4* LTS, 5.5*, 5.60 (x86/x64)
;             OS: Windows, Linux, Mac
;         Credit: STARGÅTE: Transformation of gadgets at runtime
;         Credit: Falsam: Tiny Visual Designer (TVD)
;  English-Forum:
;   French-Forum: http://www.purebasic.fr/french/viewtopic.php?f=3&t=16527
;   German-Forum:
; ---------------------------------------------------------------------------------------

CompilerIf #PB_Compiler_IsMainFile
  EnableExplicit
  
  ;Import internal function
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    Import ""
    CompilerElse
      ImportC ""
      CompilerEndIf
      PB_Object_EnumerateStart( PB_Objects )
      PB_Object_EnumerateNext( PB_Objects, *ID.Integer )
      PB_Object_EnumerateAbort( PB_Objects )
      PB_Object_GetObject( PB_Object , DynamicOrArrayID)
      PB_Window_Objects.i
      PB_Gadget_Objects.i
    EndImport
    
    ;Dependency: SweetyVDmodule.pbi (Sweety Visual Designer Module)
    XIncludeFile "SweetyVDmodule.pbi"
    UseModule SVDesigner
    IncludePath "Include"
    
    #INDENT = "  "
    
    Enumeration
      #MainWindow
      #DrawArea
      #PopUpMenu
      #EnableSVD
      #CodeCreate
      #SettingContainer
      #DrawSizeText
      #DrawWidth
      #DrawSizeTextX
      #DrawHeight
      #DragText
      #DragSVD
      #ShowGrid
      #GridSpacing
      #GadgetList
      #ListGadgets
      #AddGadgetButton
      #DeleteGadgetButton
      #PosGadgetX
      #PosGadgetY
      #PosGadgetWidth
      #PosGadgetHeight
      #PropertiesContainer
      #ImgProperties
      #PropertiesText
      ;Code Generator Windows
      #CodeForm
      #CodePerform    ;Generate code button
      #CodeCancel     ;Cancel code generation button
      #CodeIncEnum    ;Check box include enumeration
      #CodeIncEvent   ; Check box Include the event loop
      #Shortcut_Insert
      ;For testing
      #TextGadget
      #EditorGadget
      #ComboBox
      #ButtonGadget
      #CheckBoxGadget
      #TrackBarGadget
      #SpinGadget
      #TestButtonGadget
    EndEnumeration
    
    Enumeration FormImage
      #Img_Add
      #Img_Delete
      #Img_Properties
    EndEnumeration
    
    Enumeration Font
      #FontWML
    EndEnumeration
    
    Structure ModelWindowProperty   ;Structure Window tempate from Data Section
      Model.s                       ;OpenWindow
      Enum.s                        ;Enumeration
      Width.i                       ;Default Width
      Height.i                      ;Default Height
      Text.s                        ;Text, blank or content
      Options.s                     ;Available Options (Ex: "#PB_Window_SystemMenu,#PB_Window_ScreenCentered")
    EndStructure
    Global Dim ModelWindow.ModelWindowProperty(0)
    
    Structure ModelGadgetProperty   ;Structure Gadget templates from Data Section
      Model.s                       ;Gadget Model (ButtonGadget, TextGadget ........)
      Type.i                        ;GadgetType
      Enum.s                        ;Enumeration
      PbAny.b                       ;#Pb_Any (#True|#False)
      AddItem.b                     ;Add Items Available (#True|#False)
      Help.b                        ;Help Binary (#True|#False)
      Width.i                       ;Default Width
      Height.i                      ;Default Height
      Text.s                        ;Text, blank or content
      TypeSplitter.b                ;Type Splitter
      Options.s                     ;Available Options (Ex: "#PB_Text_Center,#PB_Text_Right,#PB_Text_Border")
      CountGadget.i                 ;Gadget Counter by Model
    EndStructure
    Global Dim ModelGadget.ModelGadgetProperty(14)
    
    Structure StructureGadget   ;Structure of gadgets. 0 is reserved for the window Draw Area
      Idgadget.i                ;Id gadget
      IdModel.i                 ;Id model
      Enum.s                    ;Enumeration
      Caption.s                 ;Caption Or Gadget content
      ModelType.i               ;0=Window, 2=Gadget, 9=Gadget Deleted
      Key.s                     ;ModelType + GadgetY(IdGadget) + GadgetX(IdGadget)
    EndStructure
    Global Dim Gadgets.StructureGadget(1), CountGadgets.i
    
    Global X.i, Y.i
    
    Declare.f AjustFontSize(Size.l)
    Declare LoadFontWML()
    Declare InitGadgetIDPos()
    Declare GadgetHoverCheck(Window.i, Gadget.i)
    Declare InitModelWindow()
    Declare InitModelgadget()
    Declare CreateGadgets(IdModel.i)
    Declare LoadPBObjectEnum()
    Declare CodeGenerateForm()
    Declare ResizeDrawArea(Width.i, Height.i)
    Declare WindowSize()
    Declare OpenMainWindow(SelectDrawArea.l = 0, X = 0, Y = 0, Width = 800, Height = 530)
    Declare SVDGadgetTest()
    Declare Exit()
    
    UsePNGImageDecoder()
    
    Procedure.f AjustFontSize(lSize.l)   ;Windows DPI aware by using the font size based on the number of pixels per inch along the screen
      Define.i iimage
      Static.f fPpp
      CompilerIf #PB_Compiler_OS = #PB_OS_MacOS   ;How to with Mac retina display
        ProcedureReturn lSize
      CompilerElse
        If fPpp = 0
          iimage = CreateImage(#PB_Any,1,1)
          If IsImage(iimage)
            If StartVectorDrawing(ImageVectorOutput(iimage))
              fPpp = VectorResolutionX()
              StopVectorDrawing()
            EndIf
            FreeImage(iimage)
          EndIf
        EndIf
        ProcedureReturn (lSize * 96) / fPpp
      CompilerEndIf
    EndProcedure
    
    Procedure LoadFontWML()   ;Most common fonts on Windows, Mac, and linux/Unix OS with +- a similar size: Verdana, Arial, courrier New.
      If LoadFont(#FontWML, "Verdana", AjustFontSize(8))
        SetGadgetFont(#PB_Default, FontID(#FontWML))   ; Set the loaded Arial 8 font as new default font for all Gadgets
      ElseIf LoadFont(#FontWML, "Arial", AjustFontSize(8))
        SetGadgetFont(#PB_Default, FontID(#FontWML))   ; Set the loaded Arial 8 font as new default font for all Gadgets
      EndIf                                            ;If not loaded: SetGadgetFont(#PB_Default, #PB_Default): set the font settings back to original standard font
    EndProcedure
    
    Procedure InitGadgetIDPos()
      SetGadgetState(#ListGadgets, 0)
      SetGadgetState(#PosGadgetX, 0) : SetGadgetState(#PosGadgetY, 0)
      SetGadgetState(#PosGadgetWidth, GetGadgetState(#DrawWidth)) : SetGadgetState(#PosGadgetHeight, GetGadgetState(#DrawHeight))
    EndProcedure
    
    Procedure GadgetHoverCheck(Window.i, Gadget.i)
      Protected X, Y
      Protected Mx = WindowMouseX(Window), My = WindowMouseY(Window)
      If IsGadget(Gadget)
        X = GadgetX(Gadget) : Y = GadgetY(Gadget)
        If Mx > X And Mx < (X + GadgetWidth(Gadget)) And My > Y And My < (Y + GadgetHeight(Gadget) )
          ProcedureReturn 1   ;Mouse is on Gadget
        EndIf
      EndIf
      ProcedureReturn 0   ;Mouse is not on Gadget
    EndProcedure
    
    Procedure InitModelWindow()   ;Initializing Window Templates
      Protected Buffer.s, ScrollMargin = 20, I.i
      Restore ModelWindow
      With ModelWindow(0)
        For I=1 To 6
          Read.s Buffer
          Select I
            Case 1 : \Model=Buffer
            Case 2 : \Width=Val(Buffer)
            Case 3 : \Height=Val(Buffer)
            Case 4 : \Text=Buffer
            Case 5 : \Enum=Buffer
            Case 6 : \Options=Buffer
          EndSelect
        Next
        ;Draw Area Width and Height with associated Spin Gadgets
        SetGadgetState(#PosGadgetWidth, \Width)
        SetGadgetState(#PosGadgetHeight, \Height)
        SetGadgetState(#DrawWidth, \Width)
        SetGadgetState(#DrawHeight,  \Height)
        If GadgetX(#DrawArea) + \Width + ScrollMargin + 10 > WindowWidth(#MainWindow)
          ResizeGadget(#DrawArea, #PB_Ignore, #PB_Ignore, WindowWidth(#MainWindow) - GadgetX(#DrawArea) - 10, #PB_Ignore)
        Else
          ResizeGadget(#DrawArea, #PB_Ignore, #PB_Ignore, \Width + ScrollMargin, #PB_Ignore)
        EndIf
        SetGadgetAttribute(#DrawArea, #PB_ScrollArea_InnerWidth, \Width)
        If GadgetY(#DrawArea) + \Height + ScrollMargin + 10 > WindowHeight(#MainWindow)   ;To display the scrollbar
          ResizeGadget(#DrawArea, #PB_Ignore, #PB_Ignore, #PB_Ignore, WindowHeight(#MainWindow) - GadgetY(#DrawArea) - 10)
        Else
          ResizeGadget(#DrawArea, #PB_Ignore, #PB_Ignore, #PB_Ignore, \Height + ScrollMargin)
        EndIf
        SetGadgetAttribute(#DrawArea, #PB_ScrollArea_InnerHeight, \Height)
        DrawAreaSize(#DrawArea)
        ;Save window information in the gadget List. Element 0
        Gadgets(0)\IdGadget=#MainWindow
        Gadgets(0)\IdModel=0
        Gadgets(0)\Caption=\Text
        Gadgets(0)\Enum="#"+\Enum
        Gadgets(0)\ModelType=0
        ;Add Window to List Gadgets ComboBox. Element 0 for the Window Draw Area
        AddGadgetItem(#ListGadgets, -1, "#"+\Enum)
        SetGadgetState(#ListGadgets, 0)
        SetGadgetItemData(#ListGadgets, 0, 0)
      EndWith
    EndProcedure
    
    Procedure InitModelgadget()   ;Initializing Gadget Templates
      Protected Buffer.s, I.i, J.i
      Restore ModelGadgets
      For I=1 To 14
        With ModelGadget(I)
          For J=1 To 11
            Read.s Buffer
            Select J
              Case 1  : \Model=Buffer
              Case 2  : \Type=Val(Buffer)
              Case 3  : \Width=Val(Buffer)
              Case 4  : \Height=Val(Buffer)
              Case 5  : \Text=Buffer
              Case 6  : \Enum=Buffer
              Case 7  : \PbAny=Val(Buffer)
              Case 8  : \AddItem=Val(Buffer)
              Case 9  : \Help=Val(Buffer)
              Case 10 : \TypeSplitter=Val(Buffer)
              Case 11 : \Options=Buffer
            EndSelect
          Next
          MenuItem((I), \Model)   ;Add to popup menu
        Next
      EndWith
    EndProcedure
    
    Procedure CreateGadgets(IdModel.i)
      Protected IdGadget.i, Width.i, Height.i, Caption.s
      OpenGadgetList(#DrawArea)
      With ModelGadget(IdModel)
        \CountGadget=\CountGadget+1   ;Updating the gadget counter by model
        CountGadgets=CountGadgets+1
        ReDim Gadgets(CountGadgets)
        
        X = Round(X/MyGrid, #PB_Round_Down)*MyGrid   ;Align on Grid
        Y = Round(Y/MyGrid, #PB_Round_Down)*MyGrid
        ;Default values from the gadget models table
        Width=\Width
        Height=\Height
        If \Text = "Enum"
          Caption=\Enum+Str(\CountGadget)
        Else
          Caption=\Text
        EndIf
        
        Select IdModel   ;Create Gadget depending on model
          Case 1  : IdGadget=ButtonGadget(#PB_Any, X, Y, Width, Height, Caption)
          Case 2
            IdGadget=CanvasGadget(#PB_Any, X, Y, Width, Height)
            If StartDrawing(CanvasOutput(IdGadget))
              DrawText(5, 5, \Enum+Str(\CountGadget), #Blue, #White)
              StopDrawing()
            EndIf
          Case 3  : IdGadget=CheckBoxGadget(#PB_Any, X, Y, Width, Height, Caption)
          Case 4
            IdGadget=ComboBoxGadget(#PB_Any, X, Y, Width, Height, #PB_ComboBox_Editable)
            AddGadgetItem(Idgadget,-1,Caption)
          Case 5
            IdGadget=EditorGadget(#PB_Any, X, Y, Width, Height, #PB_Editor_ReadOnly)
            AddGadgetItem(IdGadget, 0, Caption)
          Case 6  : IdGadget=FrameGadget(#PB_Any, X, Y, Width, Height, Caption)
          Case 7   ;We cheat with a Canvas instead of ImageGadget
            IdGadget=CanvasGadget(#PB_Any, X, Y, Width, Height)
            If StartDrawing(CanvasOutput(IdGadget))
              DrawText(5, 5, \Enum+Str(\CountGadget), #Blue, #White)
              StopDrawing()
            EndIf
          Case 8  : IdGadget=ListIconGadget(#PB_Any, X, Y, Width, Height, Caption, 100)
          Case 9  : IdGadget=ListViewGadget(#PB_Any, X, Y, Width, Height)
          Case 10  : IdGadget=OptionGadget(#PB_Any, X, Y, Width, Height, Caption)
          Case 11
            IdGadget=SpinGadget(#PB_Any, X, Y, Width, Height, 0, 100)
            SetGadgetText(IdGadget, Caption)
          Case 12
            IdGadget=StringGadget(#PB_Any, X, Y, Width, Height, Caption, #PB_String_ReadOnly)
            SetGadgetColor(IdGadget, #PB_Gadget_BackColor, RGB(255, 255, 255))
          Case 13 : IdGadget=TextGadget(#PB_Any, X, Y, Width, Height, Caption)
          Case 14
            IdGadget=TrackBarGadget(#PB_Any, X, Y, Width, Height, 0, 100)
            SetGadgetState(IdGadget, Val(Caption))
        EndSelect
        
        SetGadgetData(IdGadget, CountGadgets)   ;Add Gadget Counter to Gadget Data
        ;Save gadget information in the gadget List
        Gadgets(CountGadgets)\IdGadget=Idgadget
        Gadgets(CountGadgets)\IdModel=IdModel
        Gadgets(CountGadgets)\Caption=Caption
        If \PbAny=#True   ;Enumeration
          Gadgets(CountGadgets)\Enum=\Enum+Str(\CountGadget)
        Else
          Gadgets(CountGadgets)\Enum="#"+\Enum+Str(\CountGadget)
        EndIf
        Gadgets(CountGadgets)\ModelType=2
        ;Add Gadget to List Gadgets ComboBox with IdGadget as Data. Element 0 is reserved for Window Draw Area
        AddGadgetItem(#ListGadgets, -1, Gadgets(CountGadgets)\Enum)
        SetGadgetState(#ListGadgets, CountGadgetItems(#ListGadgets)-1)
        SetGadgetItemData(#ListGadgets, CountGadgetItems(#ListGadgets)-1, IdGadget)
        ;Add Drag Handle Gadget in module
        AddSVDGadget(#DrawArea, IdGadget)
      EndWith
    EndProcedure
    
    Procedure LoadPBObjectEnum()
      Protected GadgetObj.i, I.i
      ;Create Gadgets from PB Object Enumeration. To see if there is a way to load them from SweetyVD.exe !
      PB_Object_EnumerateStart(PB_Gadget_Objects)
      While PB_Object_EnumerateNext(PB_Gadget_Objects, @GadgetObj)
        If GetGadgetData(GadgetObj) <> #PB_Ignore
          For I = 0 To ArraySize(ModelGadget())
            With ModelGadget(I)
              If \Type = GadgetType(GadgetObj)
                
                \CountGadget=\CountGadget+1   ;   ;Updating the gadget counter by model
                CountGadgets=CountGadgets+1
                ReDim Gadgets(CountGadgets)
                
                SetGadgetData(GadgetObj, CountGadgets)   ;)   ;Add Gadget Counter to Gadget Data
                                                         ;Save gadget information in the gadget List
                Gadgets(CountGadgets)\IdGadget=GadgetObj
                Gadgets(CountGadgets)\IdModel=I
                Gadgets(CountGadgets)\Caption=\Enum+Str(\CountGadget)
                ;Enumération
                If \PbAny=#True
                  Gadgets(CountGadgets)\Enum=\Enum+Str(\CountGadget)
                Else
                  Gadgets(CountGadgets)\Enum="#"+\Enum+Str(\CountGadget)
                EndIf
                Gadgets(CountGadgets)\ModelType=2
                ;Add Gadget to List Gadgets ComboBox with IdGadget as Data. Element 0 is reserved for Window Draw Area
                AddGadgetItem(#ListGadgets, -1, Gadgets(CountGadgets)\Enum)
                SetGadgetState(#ListGadgets, CountGadgetItems(#ListGadgets)-1)
                SetGadgetItemData(#ListGadgets, CountGadgetItems(#ListGadgets)-1, GadgetObj)
                Break
              EndIf
            Next
          EndWith
        EndIf
      Wend
    EndProcedure
    
    Procedure CodeGenerateForm()
      Protected AnyGadgets.b = #False, I.i
      For I = 1 To ArraySize(Gadgets())   ;At least one Gadget is required
        If Gadgets(I)\Idgadget > 0 And Gadgets(I)\ModelType=2
          AnyGadgets = #True
          Break
        EndIf
      Next
      
      If AnyGadgets   ;If at least one Gadget
        If OpenWindow(#CodeForm, WindowX(#MainWindow)+GadgetX(#CodeCreate), WindowY(#MainWindow)+70 , 230 , 120, "SweetyVD: Pure Basic code Generation",#PB_Window_TitleBar)
          CheckBoxGadget(#CodeIncEnum, 40, 10, 160, 25, "include enumeration") : SetGadgetState(#CodeIncEnum, #PB_Checkbox_Checked)
          CheckBoxGadget(#CodeIncEvent, 40, 40, 160, 25, "Include the event loop") : SetGadgetState(#CodeIncEvent, #PB_Checkbox_Checked)
          ButtonGadget(#CodePerform, 20, 80, 80, 25, "Generate")
          ButtonGadget(#CodeCancel, 130, 80, 80, 25, "Cancel")
        EndIf
      Else
        MessageRequester("SweetyVD Information", "Let me play with at least one Gadget. Please  ;)", #PB_MessageRequester_Info|#PB_MessageRequester_Ok)
      EndIf
    EndProcedure
    
    Procedure CodeGenerate()
      Protected Dim Buffer.StructureGadget(0)
      Protected IdGadget.i, SavModelType = -1
      Protected Code.s, Model.s, Enum.s, X.s, Y.s, Width.s, Height.s, Caption.s, I.i, J.i
      
      CopyArray(Gadgets(), Buffer())   ;Sort: Creation of the Model key (Window or Gadget) + Position X + Position Y
      For I=0 To ArraySize(Buffer())
        With Buffer(I)
          If \ModelType = 9   ;Gadget Deleted
            \Key = Str(\ModelType) + RSet("0", 5, "0") + RSet("0", 5, "0")
          ElseIf \ModelType = 2
            \Key = Str(\ModelType) + RSet(Str(GadgetY(\Idgadget)), 5, "0") + RSet(Str(GadgetX(\Idgadget)), 5, "0")
          Else
            \Key = Str(\ModelType) + RSet("0", 5, "0") + RSet("0", 5, "0")
          EndIf
        EndWith
      Next
      SortStructuredArray(Buffer(), #PB_Sort_Ascending, OffsetOf(StructureGadget\Key), TypeOf(StructureGadget\Key))
      
      ;Génération du code
      Code = "; -----------------------------------------------------------------------------" + #CRLF$
      Code + ";           Name:" + #CRLF$
      Code + ";    Description:" + #CRLF$
      Code + ";         Author:" + #CRLF$
      Code + ";           Date: " + FormatDate("%yyyy-%mm-%dd", Date()) + #CRLF$
      Code + ";        Version:" + #CRLF$
      Code + ";     PB-Version:" + #CRLF$
      Code + ";             OS:" + #CRLF$
      Code + ";         Credit: ChrisR: This code was generated by SweetyVD" + #CRLF$
      Code + ";   French-Forum: http://www.purebasic.fr/french/viewtopic.php?f=3&t=16527" + #CRLF$
      Code + "; -----------------------------------------------------------------------------" + #CRLF$+#CRLF$
      Code + "EnableExplicit" + #CRLF$+#CRLF$
      
      If GetGadgetState(#CodeIncEnum)=#True   ;Include Enumeration
        For I=0 To ArraySize(Buffer())
          If Buffer(I)\ModelType = 9 : Break : EndIf   ;Gadget Deleted
          Select Buffer(I)\ModelType
            Case 0
              If Buffer(I)\ModelType <> SavModelType
                SavModelType = Buffer(I)\ModelType
                Code=Code+"Enumeration Window"+#CRLF$
              EndIf
              
            Case 1
              If Buffer(I)\ModelType <> SavModelType
                SavModelType = Buffer(I)\ModelType
                Code=Code+"EndEnumeration"+#CRLF$+#CRLF$
                Code=Code+"Enumeration StatusBar"+#CRLF$
              EndIf
              
            Case 2
              If Buffer(I)\ModelType <> SavModelType
                SavModelType = Buffer(I)\ModelType
                Code=Code+"EndEnumeration"+#CRLF$+#CRLF$
                Code=Code+"Enumeration Gadgets"+#CRLF$
              EndIf
          EndSelect
          
          If Buffer(I)\Enum<>"#Pb_Any"
            Code=Code+#INDENT+Buffer(I)\Enum+#CRLF$
          EndIf
        Next
        Code=Code+"EndEnumeration"+#CRLF$+#CRLF$
        Code=Code+"Define.l Event"+#CRLF$+#CRLF$
      EndIf
      
      ;Window being created
      Enum=Buffer(0)\Enum
      X="0"
      Y="0"
      Width=GetGadgetText(#DrawWidth)
      Height=GetGadgetText(#DrawHeight)
      Caption=Buffer(0)\Caption
      
      Code=Code+"Declare Open_"+Mid(Enum,2,Len(Enum)-1)+"(X = "+X+", Y = "+Y+", Width = "+Width+", Height = "+Height+")"+#CRLF$+#CRLF$
      Code=Code+"Open_"+Mid(Enum,2,Len(Enum)-1)+"()"+#CRLF$+#CRLF$
      Code=Code+"Procedure Open_"+Mid(Enum,2,Len(Enum)-1)+"(X = "+X+", Y = "+Y+", Width = "+Width+", Height = "+Height+")"+#CRLF$
      Code=Code+#INDENT+"If OpenWindow("+Enum+", X, Y, Width, Height, "+#DQUOTE$+Caption+#DQUOTE$
      
;       If Buffer(0)\Options<>""   ;Are there any options for the window
;         Code=Code+","+Buffer(0)\Options
      Code=Code+", "+"#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_SystemMenu"
;       EndIf
      
      Code=Code+")"+#CRLF$   ;End of generation of the window code
      
;         For I=1 To CountGadgets   ;Is there a status bar
;           If Buffer(I)\ModelType = 1
;             Code + #INDENT+#INDENT + "CreateStatusBar(" + Buffer(1)\Enum +", WindowID(" + Buffer(0)\Enum + "))" + #CRLF$
;           EndIf
;         Next
        
      ;Beginning of the creation of Gadgets
      For I=1 To ArraySize(Buffer())
        If Buffer(I)\ModelType = 9 : Break : EndIf   ;Gadget Deleted
        If Buffer(I)\ModelType <> 1
          IdGadget=Buffer(I)\IdGadget
          Model=ModelGadget(Buffer(I)\IdModel)\Model
          Enum=Buffer(I)\Enum
          X=Str(GadgetX(IdGadget))
          Y=Str(GadgetY(IdGadget))
          Width=Str(GadgetWidth(IdGadget))
          Height=Str(GadgetHeight(IdGadget))
          Caption=Buffer(I)\Caption
          
          Code=Code+#INDENT+#INDENT+Model+"("+Enum+", "+X+", "+Y+", "+Width+", "+Height   ;Common part (Enumeration, X, Y, Width, Height, Text)
          
          If ModelGadget(Buffer(I)\IdModel)\Text <> ""   ;Is there a text?
            Code=Code+", "+#DQUOTE$+Caption+#DQUOTE$
          EndIf
          
          If Buffer(I)\IdModel=7   ;ImageGadget
            Code=Code+", 0"
          EndIf
          If Buffer(I)\IdModel=8   ;ListIconGadget
            Code=Code+", "+#DQUOTE$+GetGadgetItemText(Idgadget, -1, 0)+#DQUOTE$+", "+Str(GetGadgetItemAttribute(IdGadget, 0, #PB_ListIcon_ColumnWidth,0 ))
          EndIf
          If Buffer(I)\IdModel=11   ;SpinGadget, add Minimum and maximum values + #PB_Spin_Numeric
            Code=Code+", 0, 100, #PB_Spin_Numeric"
          EndIf
          If Buffer(I)\IdModel=14   ;TrackBarGadget, add Minimum and maximum values
            Code=Code+", 0, 100"
          EndIf
;           If Buffer(I)\Options<>""      ;Are there any options for the gadgets
;             Code=Code+","+Buffer(I)\Options
;           EndIf
          
          Code=Code+")"+#CRLF$   ;End of generation of the gadget code
          
          If Buffer(I)\IdModel=11   ;SpinGadget
            Code=Code+#INDENT+#INDENT+"SetGadgetText("+Enum+", "+#DQUOTE$+"66"+#DQUOTE$+")"+#CRLF$
          EndIf
          If Buffer(I)\IdModel=14   ;SpinGadget or TrackBarGadget, add Minimum and maximum values
            Code=Code+#INDENT+#INDENT+"SetGadgetState("+Enum+", 66)"+#CRLF$
          EndIf
;           If Buffer(I)\IdModel=9   ;List View: Column Additions
;             For J=1 To Buffer(I)\ColCount
;               Code=Code+#INDENT+#INDENT+"AddGadgetColumn("+Enum+","+Str(J)+", "+#DQUOTE$+GetGadgetItemText(Idgadget, -1, J)+#DQUOTE$+","
;               Code=Code+Str(GetGadgetItemAttribute(IdGadget, 0, #PB_ListIcon_ColumnWidth,J))+")"+#CRLF$
;             Next
;           EndIf
;     
;           If Trim(Buffer(I)\Help)<>""   ;Is there any help for this gadget
;             Code=Code+#INDENT+#INDENT+"GadgetToolTip("+Enum+","+#DQUOTE$+Buffer(I)\Help+#DQUOTE$+")"+#CRLF$
;           EndIf
          
        EndIf
      Next
      
      Code=Code+#INDENT+"EndIf"+#CRLF$
      Code=Code+"EndProcedure"+#CRLF$+#CRLF$
      
      If GetGadgetState(#CodeIncEvent)=#True   ;Event Loop
        Code=Code+"Repeat"+#CRLF$
        Code=Code+#INDENT+"Event = WaitWindowEvent()"+#CRLF$
        Code=Code+#INDENT+"Select Event"+#CRLF$
        Code=Code+#INDENT+#INDENT+"Case #PB_Event_Menu"+#CRLF$+#CRLF$
        Code=Code+#INDENT+#INDENT+"Case #PB_Event_Gadget"+#CRLF$+#CRLF$
        Code=Code+#INDENT+#INDENT+#INDENT+"Select EventGadget()"+#CRLF$
        For I=1 To ArraySize(Buffer())
          If Buffer(I)\ModelType = 9 : Break : EndIf   ;Gadget Deleted
          If Buffer(I)\IdModel=1                       ;Button
            Code=Code+#INDENT+#INDENT+#INDENT+#INDENT+"Case "+Buffer(I)\Enum+#CRLF$+#CRLF$
          EndIf
        Next
        Code=Code+#INDENT+#INDENT+#INDENT+"EndSelect"+#CRLF$+#CRLF$
        Code=Code+#INDENT+#INDENT+"Case #PB_Event_CloseWindow"+#CRLF$
        Code=Code+#INDENT+#INDENT+#INDENT+"End"+#CRLF$+#CRLF$
        Code=Code+#INDENT+"EndSelect"+#CRLF$
        Code=Code+"ForEver"+#CRLF$
      EndIf
      
      SetClipboardText(Code)   ;Copy the code to the clipboard
      FreeArray(Buffer())
      CloseWindow(#CodeForm)
      MessageRequester("SweetyVD Information", "The Generate Code is copied to the Clipboard  :)", #PB_MessageRequester_Info|#PB_MessageRequester_Ok)
    EndProcedure
    
    Procedure ResizeDrawArea(Width.i, Height.i)
      Protected ScrollMargin = 20
      If Width > 0
        If GadgetX(#DrawArea) + Width + ScrollMargin + 10 > WindowWidth(#MainWindow)
          ResizeGadget(#DrawArea, #PB_Ignore, #PB_Ignore, WindowWidth(#MainWindow) - GadgetX(#DrawArea) - 10, #PB_Ignore)
        Else
          ResizeGadget(#DrawArea, #PB_Ignore, #PB_Ignore, Width + ScrollMargin, #PB_Ignore)
        EndIf
        ResizeGadget(#GridArea, #PB_Ignore, #PB_Ignore, Width, #PB_Ignore)   ;Require for Linux and GetGadgetAttribute #PB_ScrollArea_. The canvas must be smaller
        SetGadgetAttribute(#DrawArea, #PB_ScrollArea_InnerWidth, Width)
      EndIf
      If Height > 0
        If GadgetY(#DrawArea) + Height + ScrollMargin + 10 > WindowHeight(#MainWindow)   ;To display the scrollbar
          ResizeGadget(#DrawArea, #PB_Ignore, #PB_Ignore, #PB_Ignore, WindowHeight(#MainWindow) - GadgetY(#DrawArea) - 10)
        Else
          ResizeGadget(#DrawArea, #PB_Ignore, #PB_Ignore, #PB_Ignore, Height + ScrollMargin)
        EndIf
        ResizeGadget(#GridArea, #PB_Ignore, #PB_Ignore, #PB_Ignore, Height)   ;Require for Linux and GetGadgetAttribute #PB_ScrollArea_. The canvas must be smaller
        SetGadgetAttribute(#DrawArea, #PB_ScrollArea_InnerHeight, Height)
      EndIf
      DrawAreaSize(#DrawArea)   ;For ParentWidth(Height) with max displacement value
      If GetGadgetState(#ShowGrid) = #PB_Checkbox_Checked   ;and redraw the grid
        DrawGrid(#True, GetGadgetState(#GridSpacing))
      EndIf
    EndProcedure
    
    Procedure WindowSize()
      Protected DrawMaxWidth.i, DrawMaxHeight.i, ScrollMargin = 20
      ;Adjust width and height of the scroll drawing area according to window size
      If IsGadget(#DrawArea) And GadgetType(#DrawArea) = #PB_GadgetType_ScrollArea
        DrawMaxWidth = WindowWidth(#MainWindow) - GadgetX(#DrawArea) - 10   ;10 from the right border
        If DrawMaxWidth > GetGadgetAttribute(#DrawArea,#PB_ScrollArea_InnerWidth) + ScrollMargin
          DrawMaxWidth = GetGadgetAttribute(#DrawArea,#PB_ScrollArea_InnerWidth) + ScrollMargin
        EndIf
        DrawMaxHeight = WindowHeight(#MainWindow) - GadgetY(#DrawArea) - 10   ;10 from the bottom border
        If DrawMaxHeight > GetGadgetAttribute(#DrawArea,#PB_ScrollArea_InnerHeight) + ScrollMargin
          DrawMaxHeight = GetGadgetAttribute(#DrawArea,#PB_ScrollArea_InnerHeight) + ScrollMargin
        EndIf
        ResizeGadget(#DrawArea, #PB_Ignore, #PB_Ignore, DrawMaxWidth, DrawMaxHeight)
        ;Do not resize #SettingContainer or others Main window Gadget. Gadgets become inaccessible
      EndIf
    EndProcedure
    
    Procedure OpenMainWindow(SelectDrawArea.l = 0, X = 0, Y = 0, Width = 800, Height = 530)
      Protected GadgetObj.i
      OpenWindow(#MainWindow, x, y, width, height, "SweetyVD (Visual Designer)", #PB_Window_SizeGadget | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_ScreenCentered | #PB_Window_SystemMenu)
      CreatePopupMenu(#PopUpMenu)
      ButtonGadget(#EnableSVD, 5, 5, 95, 25, "Enable SVD", #PB_Button_Toggle) : SetGadgetState(#EnableSVD, #True)
      ButtonGadget(#CodeCreate, 110, 5, 95, 25, "Create Code")
      
      ContainerGadget(#SettingContainer, 210, 5, 520, 30, #PB_Container_Raised) : HideGadget(#SettingContainer,#True)
      TextGadget(#DrawSizeText, 10, 4, 30, 20, "Size")
      SpinGadget(#DrawWidth, 40, 1, 70, 20, 1, 1920, #PB_Spin_Numeric)
      TextGadget(#DrawSizeTextX, 110, 4, 10, 20, "x", #PB_Text_Center)
      SpinGadget(#DrawHeight, 120, 1, 70, 20, 1, 1020, #PB_Spin_Numeric)
      TextGadget(#DragText, 215, 4, 75, 20, "Drag space")
      SpinGadget(#DragSVD, 290, 1, 50, 20, 1, 20, #PB_Spin_Numeric)  : SetGadgetState(#DragSVD, 10)
      CheckBoxGadget(#ShowGrid, 375, 2, 85, 20, "Show grid") : SetGadgetState(#ShowGrid, #PB_Checkbox_Checked)
      SpinGadget(#GridSpacing, 460, 1, 50, 20, 1, 50, #PB_Spin_Numeric) : SetGadgetState(#GridSpacing, 20)
      CloseGadgetList()
      
      ContainerGadget(#GadgetList, 5, 35, 200, 115, #PB_Container_Raised) : HideGadget(#GadgetList,#True)
      ComboBoxGadget(#ListGadgets, 2 ,5, 160, 22) ;Liste des gadgets
      CatchImage(#Img_Add,?Img_Add)
      ImageGadget(#AddGadgetButton, 165, 10, 0, 0, ImageID(#Img_Add))
      CatchImage(#Img_Delete,?Img_Delete)
      ImageGadget(#DeleteGadgetButton, 180, 10, 0, 0, ImageID(#Img_Delete))
      SpinGadget(#PosGadgetX, 2, 60, 70, 20, 0, 1920, #PB_Spin_Numeric) : SetGadgetState(#PosGadgetX, 0)
      SpinGadget(#PosGadgetY, 65, 35, 70, 20, 0, 1020, #PB_Spin_Numeric) : SetGadgetState(#PosGadgetY, 0)
      SpinGadget(#PosGadgetWidth, 123, 60, 70, 20, 1, 1920, #PB_Spin_Numeric)
      SpinGadget(#PosGadgetHeight, 65, 85, 70, 20, 1, 1020, #PB_Spin_Numeric)
      CloseGadgetList()
      
      ContainerGadget(#PropertiesContainer, 5, 160, 200, 295, #PB_Container_Single) : HideGadget(#PropertiesContainer,#True)
      CatchImage(#Img_Properties,?Img_Properties)
      ImageGadget(#ImgProperties, 20, 0, 0, 0, ImageID(#Img_Properties))
      TextGadget(#PropertiesText, 10, 225, 180, 20, "Properties!", #PB_Text_Center)      
      CloseGadgetList()
      
      Select SelectDrawArea   ;0=ScrollArea, 1=Container. Possible todo, to see for 2=Canvas ScrollArea
        Case 0
          ScrollAreaGadget(#DrawArea, 210, 35, 580, 480, 1920, 1020, 20, #PB_ScrollArea_Single)
        Case 1
          ContainerGadget(#DrawArea, 210, 35, 580, 480, #PB_Container_Single)
        Default
          ScrollAreaGadget(#DrawArea, 210, 35, 580, 480, 1920, 1020, 20, #PB_ScrollArea_Single)
      EndSelect
      
      ;All interface Objects must have #PB_Ignore as data. To not load them later when loading Designer
      PB_Object_EnumerateStart(PB_Gadget_Objects)
      While PB_Object_EnumerateNext(PB_Gadget_Objects, @GadgetObj)
        SetGadgetData(GadgetObj, #PB_Ignore)
      Wend
      ;*** Important *** Call InitSVD just after the drawing area: ScrollArea or Container. And before creating Gadets on it
      InitSVD(#DrawArea)
    EndProcedure
    
    Procedure SVDGadgetTest()
      TextGadget(#TextGadget, 50, 50, 200, 20, "Hello world") : ResizeGadget(#TextGadget, #PB_Ignore, #PB_Ignore, #PB_Ignore, #PB_Ignore)
      EditorGadget(#EditorGadget, 50, 100, 200, 50, #PB_Editor_WordWrap) : SetGadgetText(#EditorGadget, "On ne voit bien qu'avec le cœur. L'essentiel est invisible pour les yeux.")
      ComboBoxGadget(#ComboBox, 50, 180, 100, 25) : AddGadgetItem(#ComboBox, -1, "Bienvenue") : AddGadgetItem(#ComboBox, -1, "Welcome") : AddGadgetItem(#ComboBox, -1, "willkommen")
      ;ComboBox: Do not set load element to be displayed (SetGadgetState(#ComboBox, 1)
      ButtonGadget(#ButtonGadget, 330, 50, 140, 25, "Bonjour à tous", #PB_Button_MultiLine)
      CheckBoxGadget(#CheckBoxGadget, 340, 140, 120, 20, "Hallo Welt") : SetGadgetState(#CheckBoxGadget, #PB_Checkbox_Checked)
      TrackBarGadget(#TrackBarGadget, 320, 190, 160, 25, 0, 100) : SetGadgetState(#TrackBarGadget, 66) : ResizeGadget(#TrackBarGadget, #PB_Ignore, #PB_Ignore, #PB_Ignore, #PB_Ignore)
      SpinGadget(#SpinGadget, 340, 240, 70, 25, 800, 1920, #PB_Spin_Numeric) : SetGadgetState(#SpinGadget, 1366)
      
      LoadPBObjectEnum()
    EndProcedure
    
    ;- Main
    Define SelectDrawArea.l = 0   ;0=ScrollArea, 1=Container. Possible todo 2=Canvas
    Define *PosDim.PosDim
    Define IdGadget.i, DrawMaxWidth.i, DrawMaxHeight.i, ScrollMargin = 20, I.i
    
    LoadFontWML()
    OpenMainWindow(SelectDrawArea)
    InitModelWindow()   ;Initializing Window Templates
    InitModelgadget()   ;Initializing Gadget Templates
    BindEvent(#PB_Event_SizeWindow, @WindowSize())
    SVDGadgetTest()
    
    Repeat   ;- Event Loop
      Select WaitWindowEvent()
          
        Case #PB_Event_CloseWindow
          Exit()
          
        Case #PB_Event_LeftClick   ;does not work on Linux
          If GetGadgetState(#EnableSVD) = #False And GadgetHoverCheck(#MainWindow,#DrawArea) = #True
            InitGadgetIDPos()
          EndIf
          
        Case #PB_Event_RightClick   ;does not work on Linux
          If GetGadgetState(#EnableSVD) = #False And GadgetHoverCheck(#MainWindow,#DrawArea) = #True
            X=WindowMouseX(#MainWindow)-GadgetX(#DrawArea) : Y=WindowMouseY(#MainWindow)-GadgetY(#DrawArea)   ;Keep the coordinates of the mouse before creating the gadget
            DisplayPopupMenu(#PopUpMenu,WindowID(#MainWindow))
          EndIf
          
        Case #PB_Event_Menu   ;-> Event Menu
          Select EventMenu()
            Case 1 To 14   ;Popup menu for creating gadgets
              CreateGadgets(EventMenu())
            Case #Shortcut_Delete   ;AddKeyboardShortcut is added on #PB_EventType_Focus and RemoveKeyboardShortcut on #PB_EventType_LostFocus in module, proc SVD_Callback
              If GetGadgetState(#ListGadgets) > 0
                IdGadget=GetGadgetItemData(#ListGadgets, GetGadgetState(#ListGadgets))
                If IsGadget(IdGadget)
                  RemoveGadgetItem(#ListGadgets, GetGadgetState(#ListGadgets))
                  For I = 1 To ArraySize(Gadgets())
                    If Gadgets(I)\Idgadget = IdGadget
                      Gadgets(I)\ModelType=9
                      Break
                    EndIf
                  Next
                  DeleteSVDGadgetFromDragHandle(GetActiveGadget())
                  InitGadgetIDPos()
                EndIf
              EndIf
              
            Case #Shortcut_Insert   ;Insert key as Right Click replacement under Linux
              If GetGadgetState(#EnableSVD) = #False And GadgetHoverCheck(#MainWindow,#DrawArea) = #True
                X=WindowMouseX(#MainWindow)-GadgetX(#DrawArea) : Y=WindowMouseY(#MainWindow)-GadgetY(#DrawArea)   ;Keep the coordinates of the mouse before creating the gadget
                DisplayPopupMenu(#PopUpMenu,WindowID(#MainWindow))
              EndIf
          EndSelect
          
        Case #PB_Event_Gadget   ;-> Event Gadget
          If EventWindow()=#MainWindow
            Select EventGadget()
              Case #EnableSVD
                Select GetGadgetState(#EnableSVD)
                  Case #True
                    SetGadgetText(#EnableSVD, "Enable SVD")
                    CompilerIf #PB_Compiler_OS = #PB_OS_Linux : RemoveKeyboardShortcut(#MainWindow, #PB_Shortcut_Insert) : CompilerEndIf   ;Insert key as Right Click replacement under Linux
                    HideGadget(#SettingContainer,#True)
                    HideGadget(#GadgetList,#True)
                    HideGadget(#PropertiesContainer,#True)
                    DisableSVD()
                    DrawGrid(#False)
                    
                  Case #False   ;EnableSVD Parameters: drawing area, Drag Space
                    SetGadgetText(#EnableSVD, "Disable SVD")
                    CompilerIf #PB_Compiler_OS = #PB_OS_Linux : AddKeyboardShortcut(#MainWindow, #PB_Shortcut_Insert, #Shortcut_Insert) : CompilerEndIf   ;Insert key as Right Click replacement under Linux
                    InitGadgetIDPos()
                    HideGadget(#SettingContainer,#False)
                    HideGadget(#GadgetList,#False)
                    HideGadget(#PropertiesContainer,#False)
                    EnableSVD(#DrawArea, GetGadgetState(#DragSVD))
                    If GetGadgetState(#ShowGrid) = #PB_Checkbox_Checked
                      DrawGrid(#True, GetGadgetState(#GridSpacing))
                    Else
                      DrawGrid(#False)
                    EndIf
                EndSelect
                
              Case #CodeCreate ;Génération du code
                CodeGenerateForm()
                
              Case #ListGadgets
                If GetGadgetState(#ListGadgets) = 0
                  InitGadgetIDPos()
                Else
                  IdGadget=GetGadgetItemData(#ListGadgets, GetGadgetState(#ListGadgets))
                  If IsGadget(IdGadget)
                    SelectSVDGadget(IdGadget)
                  Else
                    InitGadgetIDPos()
                  EndIf
                EndIf
                
              Case #AddGadgetButton
                X = MyGrid : Y = MyGrid   ;coordinates for creating gadget inside #DrawArea
                DisplayPopupMenu(#PopUpMenu,WindowID(#MainWindow))
                
              Case #DeleteGadgetButton
                If GetGadgetState(#ListGadgets) > 0
                  IdGadget=GetGadgetItemData(#ListGadgets, GetGadgetState(#ListGadgets))
                  If IsGadget(IdGadget)
                    RemoveGadgetItem(#ListGadgets, GetGadgetState(#ListGadgets))
                    For I = 1 To ArraySize(Gadgets())
                      If Gadgets(I)\Idgadget = IdGadget
                        Gadgets(I)\ModelType=9
                        Break
                      EndIf
                    Next
                    DeleteSVDGadget(IdGadget)
                    InitGadgetIDPos()
                  EndIf
                EndIf
                
              Case #DragSVD
                MyGrid = GetGadgetState(#DragSVD)
                
              Case #ShowGrid
                If GetGadgetState(#ShowGrid) = #PB_Checkbox_Checked
                  DrawGrid(#True, GetGadgetState(#GridSpacing))
                Else
                  DrawGrid(#False)
                EndIf
                
              Case #GridSpacing
                If GetGadgetState(#ShowGrid) = #PB_Checkbox_Checked And GetGadgetState(#EnableSVD) = #False   ;Not to call it the first time on Linux
                  DrawGrid(#True, GetGadgetState(#GridSpacing))
                EndIf
                
              Case  #DrawWidth
                If GetGadgetState(#ListGadgets) = 0 : InitGadgetIDPos() : EndIf
                If EventType() = #PB_EventType_Change And IsGadget(#DrawArea)
                  ResizeDrawArea(GetGadgetState(#DrawWidth), #PB_Ignore)
                EndIf
                
              Case #DrawHeight
                If GetGadgetState(#ListGadgets) = 0 : InitGadgetIDPos() : EndIf
                If EventType() = #PB_EventType_Change And IsGadget(#DrawArea)
                  ResizeDrawArea(#PB_Ignore, GetGadgetState(#DrawHeight))
                EndIf
                
              Case #PosGadgetX
                If EventType() = #PB_EventType_Change And GetGadgetState(#ListGadgets) > 0
                  IdGadget=GetGadgetItemData(#ListGadgets, GetGadgetState(#ListGadgets))
                  If IsGadget(IdGadget)
                    ResizeSVDGadget(IdGadget, GetGadgetState(#PosGadgetX), -1, -1, -1)
                  EndIf
                EndIf
                
              Case #PosGadgetY
                If EventType() = #PB_EventType_Change And GetGadgetState(#ListGadgets) > 0
                  IdGadget=GetGadgetItemData(#ListGadgets, GetGadgetState(#ListGadgets))
                  If IsGadget(IdGadget)
                    ResizeSVDGadget(IdGadget, -1, GetGadgetState(#PosGadgetY), -1, -1)
                  EndIf
                EndIf
                
              Case #PosGadgetWidth
                If EventType() = #PB_EventType_Change And GetGadgetState(#ListGadgets) = 0
                  SetGadgetState(#DrawWidth, GetGadgetState(#PosGadgetWidth))
                  ResizeDrawArea(GetGadgetState(#DrawWidth), #PB_Ignore)
                Else
                  IdGadget=GetGadgetItemData(#ListGadgets, GetGadgetState(#ListGadgets))
                  If IsGadget(IdGadget)
                    ResizeSVDGadget(IdGadget, -1, -1, GetGadgetState(#PosGadgetWidth), -1)
                  EndIf
                EndIf
                
              Case #PosGadgetHeight
                If EventType() = #PB_EventType_Change And GetGadgetState(#ListGadgets) = 0
                  SetGadgetState(#DrawHeight, GetGadgetState(#PosGadgetHeight))
                  ResizeDrawArea(#PB_Ignore, GetGadgetState(#DrawHeight))
                Else
                  IdGadget=GetGadgetItemData(#ListGadgets, GetGadgetState(#ListGadgets))
                  If IsGadget(IdGadget)
                    ResizeSVDGadget(IdGadget, -1, -1, -1, GetGadgetState(#PosGadgetHeight))
                  EndIf
                EndIf
                
            EndSelect   ;#PB_Event_Gadget #MainWindow
          EndIf
          
          If EventWindow()=#CodeForm   ;Code Generation window
            Select EventGadget()
              Case #CodeCancel
                CloseWindow(#CodeForm)
              Case #CodePerform
                CodeGenerate()
            EndSelect
          EndIf
          
          Select EventType()   ;-> Receives Module Events
            Case  #SVD_Gadget_Focus
              *PosDim = EventData()
              ;On affecte le compteur de gadget global à ce nouveau gadget
              For I=0 To CountGadgetItems(#ListGadgets)
                If GetGadgetItemData(#ListGadgets, I)=EventGadget()
                  SetGadgetState(#ListGadgets,I)
                  Break
                EndIf
              Next
              SetGadgetState(#PosGadgetX, *PosDim\X)
              SetGadgetState(#PosGadgetY, *PosDim\Y)
              SetGadgetState(#PosGadgetWidth, *PosDim\Width)
              SetGadgetState(#PosGadgetHeight, *PosDim\Height)
              
            Case #SVD_Gadget_LostFocus
              
            Case #SVD_Gadget_Resize
              *PosDim = EventData()
              SetGadgetState(#PosGadgetX, *PosDim\X)
              SetGadgetState(#PosGadgetY, *PosDim\Y)
              SetGadgetState(#PosGadgetWidth, *PosDim\Width)
              SetGadgetState(#PosGadgetHeight, *PosDim\Height)
          EndSelect   ;EventType()
      EndSelect
    ForEver
    
    Procedure Exit()
      FreeArray(ModelWindow())
      FreeArray(ModelGadget())
      FreeArray(Gadgets())
      End   ;Do I need to free things
    EndProcedure
    
    DataSection   ;- Data Section (Model)
      #Img_Delete:
      IncludeBinary "delete-icon.png"
      
      #Img_Add:
      IncludeBinary "add-icon.png"
      
      #Img_Properties:        
      IncludeBinary "Properties.png"
      
      ModelWindow:
      Data.s "OpenWindow","500","400","Window_0","Window_0","#PB_Window_SystemMenu,#PB_Window_MinimizeGadget,#PB_Window_MaximizeGadget,#PB_Window_SizeGadget,#PB_Window_Invisible,#PB_Window_TitleBar,#PB_Window_BorderLess,#PB_Window_Tool,#PB_Window_ScreenCentered,#PB_Window_WindowCentered,#PB_Window_Maximize,#PB_Window_Minimize,#PB_Window_NoGadgets"
      
      ModelGadgets:   ;14 Gadgets Models
      ;data.s "Gadget", "GadgetType", "width", "Height", "Caption or Blank", "Enum", "#PB_any (#True|#False)", "Gadget With Collumn (#True|#False)", "Help (#True|#False)", "Type Splitter (#True|#False)", "Options"
      Data.s "ButtonGadget","1","100","25","Enum","Button_","0","0","1","0","#PB_Button_Right,#PB_Button_Left,#PB_Button_Default,#PB_Button_MultiLine,#PB_Button_Toggle"
      Data.s "CanvasGadget","33","150", "80","","Canvas_", "0","0","1","0","#PB_Canvas_Border,#PB_Canvas_ClipMouse,#PB_Canvas_Keyboard,#PB_Canvas_DrawFocus,#PB_Canvas_Container"
      Data.s "CheckBoxGadget","4","100","20","Enum","CheckBox_","0","0","1","0","#PB_CheckBox_Right,#PB_CheckBox_Center,#PB_CheckBox_ThreeState"
      Data.s "ComboBoxGadget"," 8","100","20","","Combo_","0","0","1","0","#PB_ComboBox_Editable,#PB_ComboBox_LowerCase,#PB_ComboBox_UpperCase,#PB_ComboBox_Image"
      Data.s "EditorGadget","22","150","50","","Editor_","0","0","1","0","#PB_Editor_ReadOnly"
      Data.s "FrameGadget","7","180","80","Enum","Frame_","0","0","1","0","#PB_Frame3D_Single,#PB_Frame3D_Double,#PB_Frame3D_Flat"
      Data.s "ImageGadget","9","150","80","","Image_", "0","0","1","0","#PB_Image_Border,#PB_Image_Raised"
      Data.s "ListIconGadget","12","180","50","","ListIcon_","0","1","1","0","#PB_ListIcon_CheckBoxes,#PB_ListIcon_MultiSelect,#PB_ListIcon_GridLines,#PB_ListIcon_FullRowSelect,#PB_ListIcon_HeaderDragDrop,#PB_ListIcon_AlwaysShowSelection"
      Data.s "ListViewGadget","6","180","50","","ListView_","0","0","1","0","#PB_ListView_MultiSelect,#PB_ListView_ClickSelect"
      Data.s "OptionGadget","5","100","20","Enum","Option_","0","0","1","0",""
      Data.s "SpinGadget","26","100","20","","Spin_","0","0","1","0","#PB_Spin_ReadOnly,#PB_Spin_Numeric"
      Data.s "StringGadget","2","100","20","Enum","String_","0","0","1","0","#PB_String_Password,#PB_String_ReadOnly,#PB_String_Numeric,#PB_String_LowerCase,#PB_String_UpperCase,#PB_String_BorderLess"
      Data.s "TextGadget","3","100","20","Enum","Text_","0","0","0","0","#PB_Text_Center,#PB_Text_Right,#PB_Text_Border"
      Data.s "TrackBarGadget","17","100","20","","TrackBar_","0","0","1","0","#PB_TrackBar_Ticks,#PB_TrackBar_Vertical"
    EndDataSection
  CompilerEndIf
  
  ;=== List: CreateGadget; GadgetType = Value ===
  ;Unknown, #PB_GadgetType_Unknown = 0                      ;WebGadget(), #PB_GadgetType_Web = 18
  ;ButtonGadget(), #PB_GadgetType_Button = 1                ;ButtonImageGadget(), #PB_GadgetType_ButtonImage = 19
  ;StringGadget(), #PB_GadgetType_String = 2                ;CalendarGadget(), #PB_GadgetType_Calendar = 20
  ;TextGadget(), #PB_GadgetType_Text = 3                    ;DateGadget(), #PB_GadgetType_Date = 21
  ;CheckBoxGadget(), #PB_GadgetType_CheckBox = 4            ;EditorGadget(), #PB_GadgetType_Editor = 22
  ;OptionGadget(), #PB_GadgetType_Option = 5                ;ExplorerListGadget(), #PB_GadgetType_ExplorerList = 23
  ;ListViewGadget(), #PB_GadgetType_ListView = 6            ;ExplorerTreeGadget(), #PB_GadgetType_ExplorerTree = 24
  ;FrameGadget(), #PB_GadgetType_Frame = 7                  ;ExplorerComboGadget(), #PB_GadgetType_ExplorerCombo = 25
  ;ComboBoxGadget(), #PB_GadgetType_ComboBox = 8            ;SpinGadget(), #PB_GadgetType_Spin = 26
  ;ImageGadget(), #PB_GadgetType_Image = 9                  ;TreeGadget(), #PB_GadgetType_Tree = 27
  ;HyperLinkGadget(), #PB_GadgetType_HyperLink = 10         ;PanelGadget(), #PB_GadgetType_Panel = 28
  ;ContainerGadget(), #PB_GadgetType_Container = 11         ;SplitterGadget(), #PB_GadgetType_Splitter = 29
  ;ListIconGadget(), #PB_GadgetType_ListIcon = 12           ;MDIGadget(), #PB_GadgetType_MDI = 30
  ;IPAddressGadget(), #PB_GadgetType_IPAddress = 13         ;ScintillaGadget(), #PB_GadgetType_Scintilla = 31
  ;ProgressBarGadget(), #PB_GadgetType_ProgressBar = 14     ;ShortcutGadget(), #PB_GadgetType_Shortcut = 32
  ;ScrollBarGadget(), #PB_GadgetType_ScrollBar = 15         ;CanvasGadget(), #PB_GadgetType_Canvas = 33
  ;ScrollAreaGadget(), #PB_GadgetType_ScrollArea = 16       ;OpenGLGadget(), #PB_GadgetType_OpenGL = 34
  ;TrackBarGadget(), #PB_GadgetType_TrackBar = 17
  
  ; IDE Options = PureBasic 5.4* LTS (Linux - x86/x64) - PureBasic 5.4* LTS, 5.5* and 5.6* (Windows - x86/x64)
  ; EnableUnicode
  ; EnableXP
  ; EnablePurifier
; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 1
; Folding = ----
; EnableXP
; UseIcon = Include\SweetyVD.ico
; Executable = SweetyVD.exe
; Compiler = PureBasic 5.60 (Windows - x86)
; EnablePurifier
; IncludeVersionInfo
; VersionField0 = 1.5.0
; VersionField1 = 1.5.0
; VersionField3 = SweetyVD.exe
; VersionField4 = 1.5.0
; VersionField5 = 1.5.0
; VersionField6 = Sweety Visual Designer
; VersionField7 = SweetyVD.exe
; VersionField8 = SweetyVD.exe
; VersionField9 = @ChrisR
; Watchlist = CodeGenerate()>Code